diff --git a/src/main/java/net/minecraft/core/net/command/helpers/EntitySelectorParser.java b/src/main/java/net/minecraft/core/net/command/helpers/EntitySelectorParser.java
new file mode 100644
index 000000000..d7eaae07c
--- /dev/null
+++ b/src/main/java/net/minecraft/core/net/command/helpers/EntitySelectorParser.java
@@ -0,0 +1,458 @@
+package net.minecraft.core.net.command.helpers;
+
+import com.mojang.brigadier.StringReader;
+import com.mojang.brigadier.exceptions.CommandSyntaxException;
+import com.mojang.brigadier.exceptions.DynamicCommandExceptionType;
+import com.mojang.brigadier.exceptions.SimpleCommandExceptionType;
+import com.mojang.brigadier.suggestion.Suggestions;
+import com.mojang.brigadier.suggestion.SuggestionsBuilder;
+import net.minecraft.core.entity.Entity;
+import net.minecraft.core.entity.player.Player;
+import net.minecraft.core.lang.I18n;
+import net.minecraft.core.net.command.exceptions.CommandExceptions;
+import net.minecraft.core.net.command.util.CommandHelper;
+import net.minecraft.core.util.phys.AABB;
+import net.minecraft.core.util.phys.Vec3;
+import org.jetbrains.annotations.Nullable;
+
+import java.util.Collections;
+import java.util.List;
+import java.util.concurrent.CompletableFuture;
+import java.util.function.*;
+
+public class EntitySelectorParser {
+    private static final SimpleCommandExceptionType EXPECTED_END_OF_OPTIONS = new SimpleCommandExceptionType(() -> I18n.getInstance().translateKey("command.argument_types.entity.selector.options.unterminated"));
+    private static final DynamicCommandExceptionType EXPECTED_OPTION_VALUE = new DynamicCommandExceptionType((value) -> () -> I18n.getInstance().translateKeyAndFormat("command.argument_types.entity.selector.options.valueless", value));
+
+    public static final BiConsumer<Entity, List<? extends Entity>> ORDER_RANDOM = (sender, entities) -> Collections.shuffle(entities);
+    public static final BiConsumer<Entity, List<? extends Entity>> ORDER_ARBITRARY = (sender, entities) -> {
+    };
+    public static final BiConsumer<Entity, List<? extends Entity>> ORDER_NEAREST = (sender, entities) -> entities.sort((firstEntity, secondEntity) -> Double.compare(firstEntity.distanceTo(sender), secondEntity.distanceTo(sender)));
+    public static final BiConsumer<Entity, List<? extends Entity>> ORDER_FURTHEST = (sender, entities) -> entities.sort((firstEntity, secondEntity) -> Double.compare(secondEntity.distanceTo(sender), firstEntity.distanceTo(sender)));
+
+    private final SimpleCommandExceptionType SELECTORS_NOT_ALLOWED = new SimpleCommandExceptionType(() -> I18n.getInstance().translateKey("command.argument_types.entity.invalid_selector.selectors_not_allowed"));
+
+    private final StringReader reader;
+    private int startPosition;
+
+    private Predicate<Entity> predicate = entity -> true;
+
+    private int maxResults;
+    private boolean includesEntities;
+    private BiConsumer<Entity, List<? extends Entity>> order;
+    private @Nullable Class<? extends Entity> limitToType;
+    private boolean typeInverse = false;
+    private boolean currentEntity;
+    private String entityId;
+    private String playerName;
+    private MinMaxBounds.Doubles distance = MinMaxBounds.Doubles.ANY;
+    private Double x;
+    private Double y;
+    private Double z;
+    private Double deltaX;
+    private Double deltaY;
+    private Double deltaZ;
+    private final boolean allowSelectors;
+
+    private BiFunction<SuggestionsBuilder, Consumer<SuggestionsBuilder>, CompletableFuture<Suggestions>> suggestions = CommandHelper.NO_SUGGESTIONS;
+
+    public EntitySelectorParser(StringReader reader) {
+        this(reader, true);
+    }
+
+    public EntitySelectorParser(StringReader reader, boolean allowSelectors) {
+        this.reader = reader;
+        this.allowSelectors = allowSelectors;
+    }
+
+    private void parseSelector() throws CommandSyntaxException {
+        this.reader.skip();
+        this.suggestions = this::suggestSelector;
+        if (!this.reader.canRead()) throw CommandExceptions.invalidSelector().createWithContext(this.reader);
+
+        switch (this.reader.read()) {
+            case 'p':
+                this.maxResults = 1;
+                this.includesEntities = false;
+                this.order = ORDER_NEAREST;
+                this.setLimitToType(Player.class);
+                this.currentEntity = false;
+                break;
+            case 'a':
+                this.maxResults = Integer.MAX_VALUE;
+                this.includesEntities = false;
+                this.order = ORDER_ARBITRARY;
+                this.setLimitToType(Player.class);
+                this.currentEntity = false;
+                break;
+            case 'r':
+                this.maxResults = 1;
+                this.includesEntities = false;
+                this.order = ORDER_RANDOM;
+                this.setLimitToType(Player.class);
+                this.currentEntity = false;
+                break;
+            case 's':
+                this.maxResults = 1;
+                this.includesEntities = true;
+                this.order = ORDER_ARBITRARY;
+                this.currentEntity = true;
+                break;
+            case 'e':
+                this.maxResults = Integer.MAX_VALUE;
+                this.includesEntities = true;
+                this.order = ORDER_ARBITRARY;
+                this.currentEntity = false;
+                break;
+            default:
+                throw CommandSyntaxException.BUILT_IN_EXCEPTIONS.dispatcherUnknownArgument().createWithContext(this.reader);
+        }
+        this.suggestions = this::suggestOpenOptions;
+        if (this.reader.canRead() && this.reader.peek() == '[') {
+            this.reader.skip();
+            this.suggestions = this::suggestOptionsKeyOrClose;
+            this.parseOptions();
+        }
+        if (this.reader.canRead() && this.reader.peek() != ' ') {
+            this.suggestions = CommandHelper.NO_SUGGESTIONS;
+        }
+    }
+
+    private void parseNameOrEntityId() throws CommandSyntaxException {
+        if (this.reader.canRead()) {
+            this.suggestions = this::suggestName;
+        }
+        String string = this.reader.readString();
+        this.maxResults = 1;
+        if (string.startsWith(EntitySelector.ENTITY_PREFIX)) {
+            this.includesEntities = true;
+            this.entityId = string;
+        } else {
+            this.includesEntities = false;
+            this.playerName = string;
+        }
+    }
+
+    public EntitySelector parse() throws CommandSyntaxException {
+        this.startPosition = this.reader.getCursor();
+        this.suggestions = this::suggestNameOrSelector;
+        if (this.reader.canRead() && this.reader.peek() == '@') {
+            if (!this.allowSelectors) {
+                throw SELECTORS_NOT_ALLOWED.createWithContext(this.reader);
+            }
+            this.parseSelector();
+        } else {
+            this.parseNameOrEntityId();
+        }
+        return this.getSelector();
+    }
+
+    private void parseOptions() throws CommandSyntaxException {
+        this.suggestions = this::suggestOptionsKey;
+        this.reader.skipWhitespace();
+        while (this.reader.canRead() && this.reader.peek() != ']') {
+            this.reader.skipWhitespace();
+            int i = this.reader.getCursor();
+            String key = this.reader.readString();
+            EntitySelectorOptions.Modifier modifier = EntitySelectorOptions.get(this, key, i);
+            this.reader.skipWhitespace();
+            if (!this.reader.canRead() || this.reader.peek() != '=') {
+                this.reader.setCursor(i);
+                throw EXPECTED_OPTION_VALUE.createWithContext(this.reader, key);
+            }
+            this.reader.skip();
+            this.reader.skipWhitespace();
+            this.suggestions = CommandHelper.NO_SUGGESTIONS;
+            modifier.handle(this);
+            this.reader.skipWhitespace();
+            this.suggestions = this::suggestOptionsNextOrClose;
+            if (!this.reader.canRead()) continue;
+            if (this.reader.peek() == ',') {
+                this.reader.skip();
+                this.suggestions = this::suggestOptionsKey;
+                continue;
+            }
+            if (this.reader.peek() == ']') break;
+            throw EXPECTED_END_OF_OPTIONS.createWithContext(this.reader);
+        }
+        if (!this.reader.canRead()) {
+            throw EXPECTED_END_OF_OPTIONS.createWithContext(this.reader);
+        }
+        this.reader.skip();
+        this.suggestions = CommandHelper.NO_SUGGESTIONS;
+    }
+
+    public EntitySelector getSelector() {
+        AABB aABB;
+        if (this.deltaX != null || this.deltaY != null || this.deltaZ != null) {
+            aABB = this.createAabb(this.deltaX == null ? 0.0 : this.deltaX, this.deltaY == null ? 0.0 : this.deltaY, this.deltaZ == null ? 0.0 : this.deltaZ);
+        } else if (this.distance.getMax() != null) {
+            double d = (Double) this.distance.getMax();
+            aABB = AABB.getTemporaryBB(-d, -d, -d, d + 1.0, d + 1.0, d + 1.0);
+        } else {
+            aABB = null;
+        }
+        Function<Vec3, Vec3> position = this.x == null && this.y == null && this.z == null ? vec3 -> vec3 : vec3 -> Vec3.getTempVec3(this.x == null ? vec3.x : this.x, this.y == null ? vec3.y : this.y, this.z == null ? vec3.z : this.z);
+        return new EntitySelector(this.maxResults, this.includesEntities, this.order, this.limitToType, this.typeInverse, this.currentEntity, this.predicate, this.entityId, this.playerName, this.distance, position, aABB);
+    }
+
+    private AABB createAabb(double d, double e, double f) {
+        boolean bl = d < 0.0;
+        boolean bl2 = e < 0.0;
+        boolean bl3 = f < 0.0;
+        double g = bl ? d : 0.0;
+        double h = bl2 ? e : 0.0;
+        double i = bl3 ? f : 0.0;
+        double j = (bl ? 0.0 : d) + 1.0;
+        double k = (bl2 ? 0.0 : e) + 1.0;
+        double l = (bl3 ? 0.0 : f) + 1.0;
+        return AABB.getTemporaryBB(g, h, i, j, k, l);
+    }
+
+    public void addPredicate(Predicate<Entity> predicate) {
+        this.predicate = this.predicate.and(predicate);
+    }
+
+    public boolean shouldInvertValue() {
+        this.reader.skipWhitespace();
+        if (this.reader.canRead() && this.reader.peek() == '!') {
+            this.reader.skip();
+            this.reader.skipWhitespace();
+            return true;
+        }
+        return false;
+    }
+
+    public StringReader getReader() {
+        return this.reader;
+    }
+
+    private static void fillSelectorSuggestions(SuggestionsBuilder builder) {
+        builder.suggest("@p", () -> I18n.getInstance().translateKey("command.argument_types.entity.selector.nearest_player"));
+        builder.suggest("@a", () -> I18n.getInstance().translateKey("command.argument_types.entity.selector.all_players"));
+        builder.suggest("@r", () -> I18n.getInstance().translateKey("command.argument_types.entity.selector.random_player"));
+        builder.suggest("@s", () -> I18n.getInstance().translateKey("command.argument_types.entity.selector.self"));
+        builder.suggest("@e", () -> I18n.getInstance().translateKey("command.argument_types.entity.selector.all_entities"));
+    }
+
+    public void setSuggestions(BiFunction<SuggestionsBuilder, Consumer<SuggestionsBuilder>, CompletableFuture<Suggestions>> biFunction) {
+        this.suggestions = biFunction;
+    }
+
+    private CompletableFuture<Suggestions> suggestNameOrSelector(SuggestionsBuilder suggestionsBuilder, Consumer<SuggestionsBuilder> consumer) {
+        consumer.accept(suggestionsBuilder);
+        fillSelectorSuggestions(suggestionsBuilder);
+        return suggestionsBuilder.buildFuture();
+    }
+
+    private CompletableFuture<Suggestions> suggestName(SuggestionsBuilder suggestionsBuilder, Consumer<SuggestionsBuilder> consumer) {
+        SuggestionsBuilder suggestionsBuilder2 = suggestionsBuilder.createOffset(this.startPosition);
+        consumer.accept(suggestionsBuilder2);
+        return suggestionsBuilder.add(suggestionsBuilder2).buildFuture();
+    }
+
+    private CompletableFuture<Suggestions> suggestSelector(SuggestionsBuilder suggestionsBuilder, Consumer<SuggestionsBuilder> consumer) {
+        SuggestionsBuilder suggestionsBuilder2 = suggestionsBuilder.createOffset(suggestionsBuilder.getStart() - 1);
+        EntitySelectorParser.fillSelectorSuggestions(suggestionsBuilder2);
+        suggestionsBuilder.add(suggestionsBuilder2);
+        return suggestionsBuilder.buildFuture();
+    }
+
+    private CompletableFuture<Suggestions> suggestOpenOptions(SuggestionsBuilder suggestionsBuilder, Consumer<SuggestionsBuilder> consumer) {
+        if (!this.reader.canRead()) suggestionsBuilder.suggest(String.valueOf('['));
+        return suggestionsBuilder.buildFuture();
+    }
+
+    private CompletableFuture<Suggestions> suggestOptionsKeyOrClose(SuggestionsBuilder suggestionsBuilder, Consumer<SuggestionsBuilder> consumer) {
+        if (!this.reader.canRead()) suggestionsBuilder.suggest(String.valueOf(']'));
+        EntitySelectorOptions.suggestNames(this, suggestionsBuilder);
+        return suggestionsBuilder.buildFuture();
+    }
+
+    private CompletableFuture<Suggestions> suggestOptionsKey(SuggestionsBuilder suggestionsBuilder, Consumer<SuggestionsBuilder> consumer) {
+        EntitySelectorOptions.suggestNames(this, suggestionsBuilder);
+        return suggestionsBuilder.buildFuture();
+    }
+
+    private CompletableFuture<Suggestions> suggestOptionsNextOrClose(SuggestionsBuilder suggestionsBuilder, Consumer<SuggestionsBuilder> consumer) {
+        if (!this.reader.canRead()) {
+            suggestionsBuilder.suggest(String.valueOf(','));
+            suggestionsBuilder.suggest(String.valueOf(']'));
+        }
+        return suggestionsBuilder.buildFuture();
+    }
+
+    public CompletableFuture<Suggestions> fillSuggestions(SuggestionsBuilder suggestionsBuilder, Consumer<SuggestionsBuilder> consumer) {
+        return this.suggestions.apply(suggestionsBuilder.createOffset(this.reader.getCursor()), consumer);
+    }
+
+    public BiFunction<SuggestionsBuilder, Consumer<SuggestionsBuilder>, CompletableFuture<Suggestions>> getSuggestions() {
+        return this.suggestions;
+    }
+
+    private boolean hasGamemodeEquals = false;
+    private boolean hasGamemodeNotEquals = false;
+    private boolean isSorted = false;
+    private boolean hasLimit = false;
+    private boolean hasType = false;
+    private boolean hasNameEquals = false;
+    private boolean hasNameNotEquals = false;
+    private boolean hasNbt = false;
+    private boolean hasNotNbt = false;
+
+    public boolean hasGamemodeEquals() {
+        return this.hasGamemodeEquals;
+    }
+
+    public void setHasGamemodeEquals(boolean bl) {
+        this.hasGamemodeEquals = bl;
+    }
+
+    public boolean hasGamemodeNotEquals() {
+        return this.hasGamemodeNotEquals;
+    }
+
+    public void setHasGamemodeNotEquals(boolean bl) {
+        this.hasGamemodeNotEquals = bl;
+    }
+
+    public boolean isSorted() {
+        return this.isSorted;
+    }
+
+    public void setSorted(boolean bl) {
+        this.isSorted = bl;
+    }
+
+    public boolean hasLimit() {
+        return this.hasLimit;
+    }
+
+    public void setHasLimit(boolean bl) {
+        this.hasLimit = bl;
+    }
+
+    public boolean hasType() {
+        return this.limitToType != null;
+    }
+
+    public boolean isTypeInverse() {
+        return this.typeInverse;
+    }
+
+    public void setTypeInverse(boolean bl) {
+        this.typeInverse = bl;
+    }
+
+    public MinMaxBounds.Doubles getDistance() {
+        return this.distance;
+    }
+
+    public void setDistance(MinMaxBounds.Doubles distance) {
+        this.distance = distance;
+    }
+
+    public boolean hasNameEquals() {
+        return this.hasNameEquals;
+    }
+
+    public void setHasNameEquals(boolean bl) {
+        this.hasNameEquals = bl;
+    }
+
+    public boolean hasNameNotEquals() {
+        return this.hasNameNotEquals;
+    }
+
+    public void setHasNameNotEquals(boolean bl) {
+        this.hasNameNotEquals = bl;
+    }
+
+    public void setMaxResults(int maxResults) {
+        this.maxResults = maxResults;
+    }
+
+    public void setIncludesEntities(boolean includesEntities) {
+        this.includesEntities = includesEntities;
+    }
+
+    public void setOrder(BiConsumer<Entity, List<? extends Entity>> order) {
+        this.order = order;
+    }
+
+    public void setLimitToType(Class<? extends Entity> type) {
+        this.limitToType = type;
+    }
+
+    public void setCurrentEntity(boolean currentEntity) {
+        this.currentEntity = currentEntity;
+    }
+
+    public boolean hasNbt() {
+        return this.hasNbt;
+    }
+
+    public void setHasNbt(boolean bl) {
+        this.hasNbt = bl;
+    }
+
+    public boolean hasNotNbt() {
+        return this.hasNotNbt;
+    }
+
+    public void setHasNotNbt(boolean bl) {
+        this.hasNotNbt = bl;
+    }
+
+    public void setX(double x) {
+        this.x = x;
+    }
+
+    public void setY(double y) {
+        this.y = y;
+    }
+
+    public void setZ(double z) {
+        this.z = z;
+    }
+
+    public void setDeltaX(double deltaX) {
+        this.deltaX = deltaX;
+    }
+
+    public void setDeltaY(double deltaY) {
+        this.deltaY = deltaY;
+    }
+
+    public void setDeltaZ(double deltaZ) {
+        this.deltaZ = deltaZ;
+    }
+
+    public Double getX() {
+        return this.x;
+    }
+
+    public Double getY() {
+        return this.y;
+    }
+
+    public Double getZ() {
+        return this.z;
+    }
+
+    public Double getDeltaX() {
+        return this.deltaX;
+    }
+
+    public Double getDeltaY() {
+        return this.deltaY;
+    }
+
+    public Double getDeltaZ() {
+        return this.deltaZ;
+    }
+
+    public boolean isCurrentEntity() {
+        return this.currentEntity;
+    }
+}
diff --git a/src/main/java/net/minecraft/core/net/command/helpers/IntegerCoordinate.java b/src/main/java/net/minecraft/core/net/command/helpers/IntegerCoordinate.java
new file mode 100644
index 000000000..02e3b32b5
--- /dev/null
+++ b/src/main/java/net/minecraft/core/net/command/helpers/IntegerCoordinate.java
@@ -0,0 +1,51 @@
+package net.minecraft.core.net.command.helpers;
+
+import com.mojang.brigadier.StringReader;
+import com.mojang.brigadier.exceptions.CommandSyntaxException;
+import net.minecraft.core.net.command.exceptions.CommandExceptions;
+import org.jetbrains.annotations.Nullable;
+
+public class IntegerCoordinate {
+    private final boolean isRelative;
+    private final int coordinate;
+
+    public IntegerCoordinate(boolean isRelative, int coordinate) {
+        this.isRelative = isRelative;
+        this.coordinate = coordinate;
+    }
+
+    public int get(@Nullable Integer sourceCoordinate) throws CommandSyntaxException {
+        if (this.isRelative) {
+            if (sourceCoordinate != null) {
+                return sourceCoordinate + this.coordinate;
+            } else {
+                throw CommandExceptions.notInWorld().create();
+            }
+        }
+
+        return this.coordinate;
+    }
+
+    public static IntegerCoordinate parse(StringReader reader) throws CommandSyntaxException {
+        if (!reader.canRead()) throw CommandExceptions.incomplete().createWithContext(reader);
+
+        if (reader.peek() == '~') {
+            reader.skip();
+            if (reader.canRead() && reader.peek() != ' ') {
+                int coordinate = reader.readInt();
+                return new IntegerCoordinate(true, coordinate);
+            } else {
+                return new IntegerCoordinate(true, 0);
+            }
+        } else if (reader.peek() != ' ') {
+            int coordinate = reader.readInt();
+            return new IntegerCoordinate(false, coordinate);
+        }
+
+        throw CommandSyntaxException.BUILT_IN_EXCEPTIONS.readerExpectedInt().createWithContext(reader);
+    }
+
+    public boolean isRelative() {
+        return this.isRelative;
+    }
+}
diff --git a/src/main/java/net/minecraft/core/net/command/helpers/IntegerCoordinates.java b/src/main/java/net/minecraft/core/net/command/helpers/IntegerCoordinates.java
new file mode 100644
index 000000000..e207a616c
--- /dev/null
+++ b/src/main/java/net/minecraft/core/net/command/helpers/IntegerCoordinates.java
@@ -0,0 +1,82 @@
+package net.minecraft.core.net.command.helpers;
+
+import com.mojang.brigadier.exceptions.CommandSyntaxException;
+import net.minecraft.core.net.command.CommandSource;
+import net.minecraft.core.net.command.exceptions.CommandExceptions;
+import org.jetbrains.annotations.Nullable;
+
+public class IntegerCoordinates {
+    private final IntegerCoordinate x;
+    private final IntegerCoordinate y;
+    private final IntegerCoordinate z;
+
+    public IntegerCoordinates(IntegerCoordinate x, IntegerCoordinate y, IntegerCoordinate z) {
+        this.x = x;
+        this.y = y;
+        this.z = z;
+    }
+
+    public int getX(@Nullable Integer sourceX) throws CommandSyntaxException {
+        return this.x.get(sourceX);
+    }
+
+    public int getY(@Nullable Integer sourceY) throws CommandSyntaxException {
+        return this.y.get(sourceY);
+    }
+
+    public int getZ(@Nullable Integer sourceZ) throws CommandSyntaxException {
+        return this.z.get(sourceZ);
+    }
+
+    public int getX(@Nullable Double sourceX) throws CommandSyntaxException {
+        if (sourceX == null) return this.x.get(null);
+        return this.x.get((int) Math.floor(sourceX));
+    }
+
+    public int getY(@Nullable Double sourceY) throws CommandSyntaxException {
+        if (sourceY == null) return this.y.get(null);
+        return this.y.get((int) Math.floor(sourceY));
+    }
+
+    public int getZ(@Nullable Double sourceZ) throws CommandSyntaxException {
+        if (sourceZ == null) return this.z.get(null);
+        return this.z.get((int) Math.floor(sourceZ));
+    }
+
+    public int getX(CommandSource source) throws CommandSyntaxException {
+        if (source.getCoordinates(true) == null) {
+            if (!this.x.isRelative()) {
+                return this.x.get(0);
+            } else {
+                throw CommandExceptions.notInWorld().create();
+            }
+        }
+        return this.x.get((int) Math.floor(source.getCoordinates(true).x));
+    }
+
+    public int getY(CommandSource source, boolean offsetHeight) throws CommandSyntaxException {
+        if (source.getCoordinates(offsetHeight) == null) {
+            if (!this.y.isRelative()) {
+                return this.y.get(0);
+            } else {
+                throw CommandExceptions.notInWorld().create();
+            }
+        }
+        return this.y.get((int) Math.floor(source.getCoordinates(offsetHeight).y));
+    }
+
+    public int getZ(CommandSource source) throws CommandSyntaxException {
+        if (source.getCoordinates(true) == null) {
+            if (!this.z.isRelative()) {
+                return this.z.get(0);
+            } else {
+                throw CommandExceptions.notInWorld().create();
+            }
+        }
+        return this.z.get((int) Math.floor(source.getCoordinates(true).z));
+    }
+
+    public boolean hasRelativeCoordinate() {
+        return this.x.isRelative() || this.y.isRelative() || this.z.isRelative();
+    }
+}
diff --git a/src/main/java/net/minecraft/core/net/command/helpers/ItemStackArgumentParser.java b/src/main/java/net/minecraft/core/net/command/helpers/ItemStackArgumentParser.java
new file mode 100644
index 000000000..ce1c34d85
--- /dev/null
+++ b/src/main/java/net/minecraft/core/net/command/helpers/ItemStackArgumentParser.java
@@ -0,0 +1,71 @@
+package net.minecraft.core.net.command.helpers;
+
+import com.mojang.brigadier.StringReader;
+import com.mojang.brigadier.exceptions.CommandSyntaxException;
+import com.mojang.brigadier.exceptions.SimpleCommandExceptionType;
+import com.mojang.brigadier.suggestion.Suggestions;
+import com.mojang.brigadier.suggestion.SuggestionsBuilder;
+import com.mojang.nbt.CompoundTag;
+import net.minecraft.core.item.Item;
+import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.lang.I18n;
+import net.minecraft.core.net.command.util.CommandHelper;
+
+import java.util.concurrent.CompletableFuture;
+import java.util.function.Consumer;
+
+public class ItemStackArgumentParser extends ArgumentParser {
+    private static final SimpleCommandExceptionType INVALID_ITEM = new SimpleCommandExceptionType(() -> I18n.getInstance().translateKey("command.argument_types.item.invalid_item"));
+
+    private Item item;
+    private int metadata = 0;
+    private CompoundTag tag = new CompoundTag();
+
+    public ItemStackArgumentParser(StringReader reader) {
+        super(reader);
+    }
+
+    private CompletableFuture<Suggestions> suggestItems(SuggestionsBuilder suggestionsBuilder, Consumer<SuggestionsBuilder> consumer) {
+        SuggestionsBuilder suggestionsBuilder2 = suggestionsBuilder.createOffset(this.startPosition);
+        consumer.accept(suggestionsBuilder2);
+        return suggestionsBuilder.add(suggestionsBuilder2).buildFuture();
+    }
+    
+    public ItemStack parse() throws CommandSyntaxException {
+        this.startPosition = this.reader.getCursor();
+
+        this.suggestions = this::suggestItems;
+        this.parseItem();
+
+        if (this.item == null) throw INVALID_ITEM.createWithContext(this.reader);
+
+        this.suggestions = this::suggestOpenMetadataOrTag;
+        if (this.reader.canRead() && this.reader.peek() == '[') {
+            this.metadata = this.parseMetadata();
+        }
+
+        if (this.reader.canRead() && this.reader.peek() == '{') {
+            this.suggestions = CommandHelper.NO_SUGGESTIONS;
+            this.tag = this.parseCompound();
+        }
+
+        if (this.item != null) {
+            return new ItemStack(this.item, 1, this.metadata, this.tag);
+        }
+        throw INVALID_ITEM.createWithContext(this.reader);
+    }
+
+    private void parseItem() throws CommandSyntaxException {
+        String string = this.reader.readString();
+        for (Item itemInList : Item.itemsList) {
+            if (itemInList == null) continue;
+            if (CommandHelper.matchesKeyString(itemInList.getKey(), string)) {
+                this.item = itemInList;
+            }
+        }
+    }
+
+    public CompletableFuture<Suggestions> fillSuggestions(SuggestionsBuilder suggestionsBuilder, Consumer<SuggestionsBuilder> consumer) {
+        return this.suggestions.apply(suggestionsBuilder.createOffset(this.reader.getCursor()), consumer);
+    }
+}
